﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Kresleni
{
    public partial class Window : Form
    {
        private Color initColor = Color.Yellow;
        private Color previewColor = Color.Green;
        private int   borderWidth = 3;

        Pen pen; // = new Pen(Color.Blue);
        Brush brush; // = new SolidBrush(Color.Blue);

        public Window()
        {
            InitializeComponent();

            pen = new Pen(colorPanel1.BackColor);
            pen.Width = borderWidth;
            brush = new SolidBrush(colorPanel2.BackColor);

            pictureBox.Image = 
                new Bitmap (pictureBox.Width, pictureBox.Height);

            Graphics g = Graphics.FromImage (pictureBox.Image);
            Brush b = new SolidBrush (initColor);
            g.FillRectangle(b, 0, 0, 
                        pictureBox.Width, pictureBox.Height); 
        }

        private void testMenu_Click(object sender, EventArgs e)
        {
            // listBox.Items.Clear ();
            // listBox.Items.Add("dee");


            foreach (Control c in this.Controls)
                listBox.Items.Add (c.Name);

            /*
            Graphics g = Graphics.FromImage(pictureBox.Image);
            Pen p = new Pen (Color.FromArgb(100, 200, 0));
            p.Width = 3;
            g.DrawLine(p, 10, 10, 100, 100);
            pictureBox.Invalidate ();
            */
        }

        private void quitItem_Click(object sender, EventArgs e)
        {
            Close ();
        }

        int X0, Y0;
        bool stisk = false;
        Bitmap save;

        private void pictureBox_MouseDown(object sender, 
                                          MouseEventArgs e)
        {
            X0 = e.X;
            Y0 = e.Y;
            stisk = true;
            save = new Bitmap (pictureBox.Image);
        }

        private void paint (MouseEventArgs e, Pen p, Brush b)
        {
            Graphics g = Graphics.FromImage(pictureBox.Image);
            g.DrawImage(save, 0, 0);

            if (e.Button == MouseButtons.Left)
            {
                g.DrawLine(p, X0, Y0, e.X, e.Y);
            }
            else if (e.Button == MouseButtons.Middle)
            {
                g.FillEllipse(b, X0, Y0, e.X - X0, e.Y - Y0);
                g.DrawEllipse(p, X0, Y0, e.X - X0, e.Y - Y0);
            }
            else if (e.Button == MouseButtons.Right)
            {
                /*
                int X = X0;
                int Y = Y0;
                int W = e.X - X0;
                int H = e.Y - Y0;
                if (W < 0) { X += W; W = -W; }
                if (H < 0) { Y += H; H = -H; }
                g.DrawRectangle(p, X, Y, W, H);
                */

                g.FillRectangle(b, Math.Min(X0, e.X),
                                   Math.Min(Y0, e.Y),
                                   Math.Abs(X0 - e.X),
                                   Math.Abs(Y0 - e.Y));
                g.DrawRectangle(p, Math.Min(X0, e.X),
                                   Math.Min(Y0, e.Y),
                                   Math.Abs(X0 - e.X),
                                   Math.Abs(Y0 - e.Y));
            }

            pictureBox.Invalidate();
        }

        private void pictureBox_MouseMove(object sender, MouseEventArgs e)
        {
            if (stisk)
            {
                Pen p = new Pen(previewColor);
                Brush b = new SolidBrush (new Color ());
                paint (e, p, b);
            }
        }

        private void pictureBox_MouseUp(object sender, MouseEventArgs e)
        {
            if (stisk)
            {
               paint (e, pen, brush);
               stisk = false;
            }
        }

        private void pictureBox_SizeChanged(object sender, EventArgs e)
        {
            Bitmap t = 
                new Bitmap (
                  Math.Max(pictureBox.Width, pictureBox.Image.Width),
                  Math.Max(pictureBox.Height, pictureBox.Image.Height)
                  );
            Graphics g = Graphics.FromImage (t);
            Brush b = new SolidBrush(initColor);
            g.FillRectangle(b, 0, 0, t.Width, t.Height);
            g.DrawImage(pictureBox.Image, 0, 0);
            pictureBox.Image = t;
        }

        private void colorPanel1_MouseDown(object sender, MouseEventArgs e)
        {
            Panel panel = sender as Panel;
            Color color = panel.BackColor;

            if (e.Button == MouseButtons.Left)
                pen.Color = color;
            else if (e.Button == MouseButtons.Right)
                brush = new SolidBrush (color);
            else if (e.Button == MouseButtons.Middle)
            {
                // DialogResult result = colorDialog.ShowDialog(); 
                // if (result == DialogResult.OK)
                colorDialog.Color = panel.BackColor;
                if (colorDialog.ShowDialog() == DialogResult.OK)
                {
                    panel.BackColor = colorDialog.Color;
                    pen.Color = colorDialog.Color;
                }
            }
        }

        private void panel2_Paint(object sender, PaintEventArgs e)
        {

        }

        int cnt = 3;

        private void addColorMenu_Click(object sender, EventArgs e)
        {
            cnt ++;

            Panel p = new Panel();
            
            p.Width = colorPanel1.Width;
            p.Height = colorPanel1.Height;
            p.Top = colorPanel1.Top;
            p.Left = colorPanel1.Left + 
                    (cnt-1) * (colorPanel2.Left - colorPanel1.Left);
            
            p.BackColor = Color.RosyBrown;

            p.MouseDown += colorPanel1_MouseDown;
            
            p.Parent = toolPanel;
            // toolPanel.Controls.Add (p);
        }

        private void addAreaMenu_Click(object sender, EventArgs e)
        {
            /*
            Panel p = new Panel ();
            p.BackColor = Color.CornflowerBlue;
            p.Parent = pictureBox;
            p.MouseDown += area_MouseDown;
            p.MouseMove += area_MouseMove;
            p.MouseUp += area_MouseUp;
            */

            MyArea a = new MyArea();
            a.Parent = pictureBox;

            MyInfo t = new MyInfo();
            t.area = a;
            listBox.Items.Add(t);

        }

        private void listBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            MyInfo t = listBox.SelectedItem as MyInfo;
            if (t != null)
                grid.SelectedObject = t.area;
            else 
                grid.SelectedObject = listBox.SelectedItem;
        }

        private void newItemButton_MouseDown(object sender, MouseEventArgs e)
        {
            newItemButton.DoDragDrop("New Item", DragDropEffects.Copy);
        }

        private void listBox_DragDrop(object sender, DragEventArgs e)
        {
            listBox.Items.Add ("Drop");
        }

        private void listBox_DragEnter(object sender, DragEventArgs e)
        {
            e.Effect = DragDropEffects.Copy;
        }

        /*
        private void area_MouseDown(object sender,
                                    MouseEventArgs e)
        {
            X0 = e.X; Y0 = e.Y; stisk = true;
        }

        private void area_MouseMove(object sender,
                                    MouseEventArgs e)
        {
            if (stisk)
            {
                Panel p = (Panel) sender;
                if (e.Button == MouseButtons.Left)
                {
                    p.Left += e.X - X0;
                    p.Top += e.Y - Y0;
                }
                else if (e.Button == MouseButtons.Right)
                {
                    p.Width += e.X - X0;
                    p.Height += e.Y - Y0;
                    X0 = e.X; 
                    Y0 = e.Y; 
                }
            }
        }

        private void area_MouseUp(object sender,
                                  MouseEventArgs e)
        {
            stisk = false;
        }
        */

    }
}
